var SwHide = 0;
var SwNormal = 1;
var SwShowMinimized = 2;
var SwMaximize = 3;
var SwShowNoActivate = 4;
var SwShow = 5;
var SwMinimize = 6;
var SwShowMinNoActivate = 7;
var SwShowNa = 8;
var SwRestore = 9;
var SwShowDefault = 10;

// Date to Digital String
function DateToDs(dtDate)
{
    return MakeDigitalDate(dtDate.getFullYear(), dtDate.getMonth() + 1, 
	dtDate.getDate());
}

function MakeDigitalDate(iYear, iMonth, iDate)
{
    var sDate;
    sDate = iYear.toString();
    sDate += ToTwoDigitString(iMonth);
    sDate += ToTwoDigitString(iDate);
    return sDate;
}

function ToTwoDigitString(i)
{
    if (i < 10)
    {
	return "0" + i.toString();
    }
    else
    {
	return i.toString();
    }
}

function ReleaseFileName(pathName)
{
    var i;
    var newPathName;
    newPathName = "";
    for (i = pathName.length - 1; i >= 0; i--)
    {
	if (pathName.charAt(i) == '\\')
	{
	    newPathName = pathName.substring(0, i);
	    break;
	}
    }
    return newPathName;
}

function FixFileName(pathName, fileName)
{
    if (pathName.length >= 1)
    {
	if (pathName.charAt(pathName.length - 1) == '\\')
	{
	    return pathName + fileName;
	}
    }
    return pathName + "\\" + fileName;
}

function GetDriveLetter(pathName)
{
    if (pathName.length >= 2)
    {
	if (pathName.charAt(1) == ':')
	{
	    return pathName.charAt(0);
	}
    }
    return ' ';
}

function ReleaseNameExtension(pathName)
{
    var newPathName;
    newPathName = "";
    for (var i = pathName.length - 1; i >= 0; i--)
    {
	if (pathName.charAt(i) == '.')
	{
	    newPathName = pathName.substring(0, i);
	    break;
	}
    }
    return newPathName;
}

function GetFileName(pathName)
{
    var fileName;
    for (var i = pathName.length - 1; i >= 0; i--)
    {
	if (pathName.charAt(i) == '\\')
	{
	    break;
	}
    }
    fileName = pathName.substring(i + 1, pathName.length);
    return fileName;
}

function QuoteCmdlnArg(arg)
{
    var i;
    var newArg;
    newArg = "\"";
    for (i = 0; i < arg.length; i++)
    {
	switch (arg.charAt(i))
	{
	case "\\":
	    if (i == arg.length - 1)
	    {
		newArg += "\\\\";
	    }
	    else
	    {
		newArg += arg.charAt(i);
	    }
	    break;
	case "\"":
	    newArg += "\\\"";
	    break;
	default:
	    newArg += arg.charAt(i);
	}
    }
    newArg += "\"";
    return newArg;
}

function URLToPath(theUrl)
{
    if (theUrl.toLowerCase().indexOf("file://") != 0)
    {
	throw "URL not local.";
    }
    var firstSlashPos;
    if ((firstSlashPos = theUrl.substring(7, theUrl.length).indexOf("/")) == -1)
    {
	throw "Host machine name not found.";
    }
    firstSlashPos += 7;
    var hostName;
    if (firstSlashPos == 7)
    {
	hostName = "localhost";
    }
    else
    {
	hostName = theUrl.substring(7, firstSlashPos).toLowerCase();
    }
    var pathString;
    if (hostName == "localhost")
    {
	pathString = "";
    }
    else
    {
	pathString = "\\\\" + hostName + "\\";
    }
    var retGetNextCharacter;	// the returned structure of GetNextCharacter
    var currentPos = firstSlashPos + 1;
    while (currentPos < theUrl.length)
    {
	retGetNextCharacter = new URL_GetNextCharacter(theUrl, currentPos);
	pathString += retGetNextCharacter.theCharacter;
	currentPos = retGetNextCharacter.nextPos;
    }
    pathString = pathString.replace(new RegExp("/", "g"), "\\");
    return pathString;
}

function URL_GetNextCharacter(theUrl, originalPos)
{
    try
    {
	var urlLen = theUrl.length;
	var charCode1;
	switch (theUrl.charAt(originalPos))
	{
	case "%":
	    if (originalPos + 2 >= urlLen)
	    {
		throw "Invalid escaped URL.";
	    }
	    charCode1 = parseInt(theUrl.substring(originalPos + 1, 
		originalPos + 3), 16);
	    // Check for DBCS
	    var dBCCFound = false;
	    if (charCode1 >= 127)
	    {
		if (theUrl.charAt(originalPos + 3) == "%")
		{
		    if (originalPos + 5 >= urlLen)
		    {
			throw "Invalid escaped URL.";
		    }
		    dBCCFound = true;
		    charCode2 = parseInt(theUrl.substring(originalPos + 4, 
			originalPos + 6), 16);
		    charCode1 = charCode1 * 256 + charCode2;
		}
	    }
	    this.nextPos = originalPos + 3;
	    if (dBCCFound)
	    {
		this.nextPos += 3;
	    }
	    this.theCharacter = ANSICodeToUnicodeCharacter(charCode1);
	    break;
	default:
	    this.nextPos = originalPos + 1;
	    this.theCharacter = theUrl.charAt(originalPos);
	    break;
	}
	return this;
    }
    catch (e)
    {
	throw "Invalid escaped URL.";
    }
}

function OpenTextFile(fileName)
{
	var ts;
	try
	{
		ts = fso.OpenTextFile(fileName);
	}
	catch (ex)
	{
		return null;
	}
	return ts;
}

function CreateTextFile(fileName, overwrite)
{
	var ts;
	try
	{
		ts = fso.CreateTextFile(fileName, overwrite);
	}
	catch (ex)
	{
		return null;
	}
	return ts;
}

function GetFileTitle(fileName)
{
	var i;
	for (i = fileName.length - 1; i >= 0; i--)
	{
		if (fileName.charAt(i) == ".")
		{
			break;
		}
	}
	if (i >= 0)
	{
		return fileName.substring(0, i);
	}
	else
	{
		return fileName;
	}
}

function ReadLine(ts)
{
	try
	{
		return ts.ReadLine();
	}
	catch (ex)
	{
		return "";
	}
}

function WriteLine(str, ts)
{
	try
	{
		ts.WriteLine(str);
		return true;
	}
	catch (ex)
	{
		return false;
	}
}

function IsSpaceChar(char)
{
	if (char == " " || char == "\t")
	{
		return true;
	}
	else
	{
		return false;
	}
}

function GetWordAt(sentence, pos, toEnd)
{
	var i;
	var j;
	var word;
	var k;
	for (i = 0, j = 0; i < pos; i++)
	{
		// begin skipping space characters
		while (j < sentence.length)
		{
			if (!IsSpaceChar(sentence.charAt(j)))
			{
				break;
			}
			j++;
		}
		if (j >= sentence.length)
		{
			return "";
		}
		// end skipping space characters
		// begin skipping a word
		while (j < sentence.length)
		{
			if (IsSpaceChar(sentence.charAt(j)))
			{
				break;
			}
			j++;
		}
		if (j >= sentence.length)
		{
			return "";
		}
		// end skipping a word
	}
	// begin skipping space characters
	while (j < sentence.length)
	{
		if (!IsSpaceChar(sentence.charAt(j)))
		{
			break;
		}
		j++;
	}
	if (j >= sentence.length)
	{
		return "";
	}
	// end skipping space characters
	if (!toEnd)
	{
		// begin copying the word
		k = j;
		while (k < sentence.length)
		{
			if (IsSpaceChar(sentence.charAt(k)))
			{
				break;
			}
			k++;
		}
		word = sentence.substring(j, k);
		// end copying the word
	}
	else
	{
		word = sentence.substring(j, sentence.length);
	}
	return word;
}
