/*
	This script creates a batch file that encodes a CD.

	There should be a source data file containing the encoding information.
	The format of the file is as follows:
	<Artist Name>
	<Album Title>
	<Encoding Method (a number)>
	<Song 1 Info>
	<Song 2 Info>
	...

	<Song Info> contains:
	<Song Title>
	<Wave File Name (without extension)>
	<MP3 File Name (without extension)>
*/

function QuoteString(str)
{
	var i;
	var newString = str;
	for (i = 0; i < str.length; )
	{
		if (newString.charAt(i) == '\"' || newString.charAt(i) == '\\')
		{
			newString = newString.substring(0, i) + "\\" + newString.substring(i, newString.length);
			i += 2;
		}
		else
		{
			i++;
		}
	}
	return "\"" + newString + "\"";
}

var ForReading = 1;
var ForWriting = 2;
var lameCommand = "D:\\lame\\lame.exe";
var fso = new ActiveXObject("Scripting.FileSystemObject");
if (WScript.Arguments.length >= 1)
{
	var dataFile = fso.GetFile(WScript.Arguments(0));
	var dataStream = dataFile.OpenAsTextStream(ForReading);
	var batStream = fso.CreateTextFile(ReleaseFileName(WScript.Arguments(0)) + "\\enc_cd.bat");
	var artistName = dataStream.ReadLine();
	var albumTitle = dataStream.ReadLine();
	var encodeMethod = dataStream.ReadLine();
	var	songTitle;
	var wavName;
	var mp3Name;
	var methodString;
	switch (parseInt(encodeMethod))
	{
	case 1:
		methodString = "--alt-preset standard";
		break;
	case 2:
		methodString = "--alt-preset 128";
		break;
	case 3:
		methodString = "--alt-preset cbr 128";
		break;
	case 4:
		methodString = "--preset tape";
		break;
	}
	while (!dataStream.AtEndOfStream)
	{
		songTitle = dataStream.ReadLine();
		wavName = dataStream.ReadLine();
		mp3Name = dataStream.ReadLine();
		batStream.WriteLine(lameCommand + " " + methodString
			+ " " + QuoteString(wavName + ".wav")
			+ " " + QuoteString(mp3Name + ".mp3")
			+ " --ta " + QuoteString(artistName)
			+ " --tl " + QuoteString(albumTitle)
			+ " --tt " + QuoteString(songTitle));
	}
	dataStream.Close();
	batStream.Close();
}
else
{
	WScript.Echo("Please specify a file.");
}
